diff -ruN tensorflow-1.15.0-rc0/tensorflow/BUILD tensorflow-1.15.0-rc0-java/tensorflow/BUILD
--- tensorflow-1.15.0-rc0/tensorflow/BUILD	2019-09-09 05:24:52.000000000 +0900
+++ tensorflow-1.15.0-rc0-java/tensorflow/BUILD	2019-09-11 11:26:47.160963284 +0900
@@ -33,7 +33,7 @@
 )
 
 package(
-    default_visibility = [":internal"],
+    default_visibility = ["//visibility:public"],
     licenses = ["notice"],  # Apache 2.0
 )
 
@@ -640,13 +640,10 @@
 tf_cc_shared_object(
     name = "tensorflow_cc",
     linkopts = select({
-        "//tensorflow:macos": [
-            "-Wl,-exported_symbols_list,$(location //tensorflow:tf_exported_symbols.lds)",
-        ],
+        "//tensorflow:macos": [],
         "//tensorflow:windows": [],
         "//conditions:default": [
-            "-z defs",
-            "-Wl,--version-script,$(location //tensorflow:tf_version_script.lds)",
+            "-s",
         ],
     }),
     per_os_targets = True,
@@ -662,12 +659,32 @@
         "//tensorflow:tf_exported_symbols.lds",
         "//tensorflow:tf_version_script.lds",
         "//tensorflow/c:c_api",
+        "//tensorflow/c:python_api",
+        "//tensorflow/c/eager:c_api",
+        "//tensorflow/cc:cc_ops",
+        "//tensorflow/cc:client_session",
+        "//tensorflow/cc:scope",
+        "//tensorflow/cc/profiler",
+        "//tensorflow/core:tensorflow",
+        "//tensorflow/java/src/main/native:native",
+    ] + if_ngraph(["@ngraph_tf//:ngraph_tf"]),
+)
+
+cc_library(
+    name = "tensorflow_static",
+    visibility = ["//visibility:public"],
+    deps = [
+        "//tensorflow:tf_exported_symbols.lds",
+        "//tensorflow:tf_version_script.lds",
+        "//tensorflow/c:c_api",
+        "//tensorflow/c:python_api",
         "//tensorflow/c/eager:c_api",
         "//tensorflow/cc:cc_ops",
         "//tensorflow/cc:client_session",
         "//tensorflow/cc:scope",
         "//tensorflow/cc/profiler",
         "//tensorflow/core:tensorflow",
+        "//tensorflow/java/src/main/native:native",
     ] + if_ngraph(["@ngraph_tf//:ngraph_tf"]),
 )
 
diff -ruN tensorflow-1.15.0-rc0/tensorflow/c/BUILD tensorflow-1.15.0-rc0-java/tensorflow/c/BUILD
--- tensorflow-1.15.0-rc0/tensorflow/c/BUILD	2019-09-09 05:24:52.000000000 +0900
+++ tensorflow-1.15.0-rc0-java/tensorflow/c/BUILD	2019-09-11 11:25:55.448904107 +0900
@@ -630,7 +630,7 @@
     name = "python_api",
     srcs = ["python_api.cc"],
     hdrs = ["python_api.h"],
-    visibility = ["//tensorflow/python:__pkg__"],
+    visibility = ["//visibility:public"],
     deps = [
         ":c_api",
         ":c_api_internal",
diff -ruN tensorflow-1.15.0-rc0/tensorflow/core/BUILD tensorflow-1.15.0-rc0-java/tensorflow/core/BUILD
--- tensorflow-1.15.0-rc0/tensorflow/core/BUILD	2019-09-09 05:24:52.000000000 +0900
+++ tensorflow-1.15.0-rc0-java/tensorflow/core/BUILD	2019-09-11 11:27:56.761042933 +0900
@@ -158,11 +158,7 @@
 # Placeholder for Google-internal load statements.
 
 package(
-    default_visibility = [
-        ":dependency_whitelist",
-        "//tensorflow:internal",
-        "//tensorflow_models:__subpackages__",
-    ],
+    default_visibility = ["//visibility:public"],
     licenses = ["notice"],  # Apache 2.0
 )
 
@@ -2864,6 +2860,7 @@
 
 tf_cuda_library(
     name = "framework_internal_impl",
+    visibility = ["//visibility:public"],
     srcs = FRAMEWORK_INTERNAL_PRIVATE_HEADERS + glob(
         [
             "example/**/*.cc",
diff -ruN tensorflow-1.15.0-rc0/tensorflow/java/BUILD tensorflow-1.15.0-rc0-java/tensorflow/java/BUILD
--- tensorflow-1.15.0-rc0/tensorflow/java/BUILD	2019-09-09 05:24:52.000000000 +0900
+++ tensorflow-1.15.0-rc0-java/tensorflow/java/BUILD	2019-09-11 11:28:15.420064286 +0900
@@ -14,7 +14,7 @@
 )
 
 package(
-    default_visibility = ["//visibility:private"],
+    default_visibility = ["//visibility:public"],
     licenses = ["notice"],  # Apache 2.0
 )
 
@@ -24,7 +24,7 @@
         ":java_op_sources",
         ":java_sources",
     ],
-    data = [":libtensorflow_jni"] + tf_binary_additional_srcs(),
+    data = tf_binary_additional_srcs(),
     javacopts = JAVACOPTS,
     plugins = [":processor"],
     visibility = ["//visibility:public"],
diff -ruN tensorflow-1.15.0-rc0/tensorflow/java/build_defs.bzl tensorflow-1.15.0-rc0-java/tensorflow/java/build_defs.bzl
--- tensorflow-1.15.0-rc0/tensorflow/java/build_defs.bzl	2019-09-09 05:24:52.000000000 +0900
+++ tensorflow-1.15.0-rc0-java/tensorflow/java/build_defs.bzl	2019-09-11 12:57:54.313937570 +0900
@@ -13,8 +13,6 @@
 # Java source to improve code consistency.
 
 XLINT_OPTS = [
-    "-Werror",
-    "-Xlint:all",
     "-Xlint:-processing",
     "-Xlint:-serial",
     "-Xlint:-try",
diff -ruN tensorflow-1.15.0-rc0/tensorflow/java/src/main/native/BUILD tensorflow-1.15.0-rc0-java/tensorflow/java/src/main/native/BUILD
--- tensorflow-1.15.0-rc0/tensorflow/java/src/main/native/BUILD	2019-09-09 05:24:52.000000000 +0900
+++ tensorflow-1.15.0-rc0-java/tensorflow/java/src/main/native/BUILD	2019-09-11 11:25:55.453904113 +0900
@@ -29,6 +29,7 @@
     }),
     hdrs = glob(["*.h"]),
     copts = tf_copts(),
+    visibility = ["//visibility:public"],
     includes = select({
         "//tensorflow:android": [],
         "//conditions:default": ["."],
diff -ruN tensorflow-1.15.0-rc0/tensorflow/python/BUILD tensorflow-1.15.0-rc0-java/tensorflow/python/BUILD
--- tensorflow-1.15.0-rc0/tensorflow/python/BUILD	2019-09-09 05:24:52.000000000 +0900
+++ tensorflow-1.15.0-rc0-java/tensorflow/python/BUILD	2019-09-11 11:25:55.455904115 +0900
@@ -4988,6 +4988,11 @@
         "//tensorflow/c:tf_status_helper",
         "//tensorflow/c/eager:c_api",
         "//tensorflow/c/eager:c_api_experimental",
+        "//tensorflow/cc:cc_ops",
+        "//tensorflow/cc:client_session",
+        "//tensorflow/cc:scope",
+        "//tensorflow/cc/profiler",
+        "//tensorflow/java/src/main/native:native",
         "//tensorflow/core/distributed_runtime/rpc:grpc_rpc_factory_registration",
         "//tensorflow/core/distributed_runtime/rpc:grpc_server_lib",
         "//tensorflow/core/distributed_runtime/rpc:grpc_session",
diff -ruN tensorflow-1.15.0-rc0/tensorflow/tensorflow.bzl tensorflow-1.15.0-rc0-java/tensorflow/tensorflow.bzl
--- tensorflow-1.15.0-rc0/tensorflow/tensorflow.bzl	2019-09-09 05:24:52.000000000 +0900
+++ tensorflow-1.15.0-rc0-java/tensorflow/tensorflow.bzl	2019-09-11 11:25:55.456904116 +0900
@@ -1945,12 +1945,9 @@
     )
     extra_linkopts = select({
         "@local_config_cuda//cuda:darwin": [
-            "-Wl,-exported_symbols_list,$(location %s.lds)" % vscriptname,
         ],
         clean_dep("//tensorflow:windows"): [],
         "//conditions:default": [
-            "-Wl,--version-script",
-            "$(location %s.lds)" % vscriptname,
         ],
     })
     extra_deps += select({
